/* Test Class to test a client> it acts like a server that
* receives and reply messsages to the client. 
*Author: Mikiko Jama
*Project: cse403
*How to use: run a client and this  class, play a client as a user 
* to test every task do the correct behavior.
*/




import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.net.*;
import java.net.InetAddress;
import java.io.*;

public class Main {
  /
  ServerSocket server;
  OutputStreamWriter out;
  Socket connection;
  InputStream in;
  String name;
  
  public Main() {
    try {
     
      server = new ServerSocket(1500);
     
          
    } catch (IOException e) {
      System.err.println("That server is bad");
    }
   
    try {
        System.out.println("server: wait for connection");
      // wait for connection
      connection = server.accept();
       if(connection != null)
            System.out.println("connection:" + connection.toString());
           
      out = new OutputStreamWriter(connection.getOutputStream());
      //out.write("change\n");
      in = new BufferedInputStream(connection.getInputStream());
      while(true) {
         System.out.println(in);
          String str = "";
            System.out.println("test");
          int c = in.read();
         // System.out.println((char)c);
          while(c != 13) {
            str += (char)c;
            c = in.read();
            //System.out.println((char)c);
          }
          System.out.println(str);
          replyMsg(str);
      }
    } catch (Exception e) {
      System.err.println("Error with accept");
    }
    System.out.println(server);
  }
    
  public void sendMsg(String msg) {
    
        try {
           if(msg != null){
          out.write( msg +"\r");
          out.flush();
           }
          //out = new OutputStreamWriter(connection.getOutputStream());
        } catch (Exception e2) {}
     
    }
  public void replyMsg(String msg){
      String[] loc = msg.split("_");
      int key = Integer.parseInt(loc[0]);
      switch(key){
          case 1://login
              if(loc.length == 2){
                  name = loc[1];
                  sendMsg("1_Mikiko-y_David-n_Calvin-n_Jung-y_");
                  
              }
              break;
          case 2://logout
              if(loc.length == 2)
                  sendMsg("2_");
              break;
          case 3://create
              if(loc.length == 2)
                  sendMsg("3_");
              break;
          case 4: //join
              if(loc.length == 2){
                 if(loc[1].equals("Mikiko") || loc[1].equals( "Jung"))
                     sendMsg("4_" + name + "_");
                 else
                     sendMsg("0_4_");
              }
              break;
          case 5://start
              sendMsg(msg);
             break;
          case 70://image
              sendMsg(msg);
              break;
         case 71://erase
              sendMsg(msg);
              break;
         case 80://color
              sendMsg(msg);
              break;
         case 81://size
              sendMsg(msg);
              break;
          case 9://answer
              if(loc.length == 2)
              sendMsg("9_Y_90_");
              break;
          case 11://nextStep
              sendMsg(msg);
              break;
          case 12: //leave game
              if(loc.length == 2)
              sendMsg("12_");
              break;
          case 13://end of session//from server
              if(name != null)
              sendMsg("13_"+ name + "_");
              break;
          case 14://game list //from server
              sendMsg("14_c-y_a-n_b-y_d-y_");
              break;
          case 100://chat
              sendMsg(msg);
              break;
          case 101://add user
              sendMsg(msg);
              break;
          case 102://remove user
             if(name != null)
              sendMsg("102_"+ name + "_");
              break;
          default://error
              sendMsg("0_0_");
              break;
            
              
      }
  }
  
  
  public static void main(String[] args) {
    Main m = new Main();
/*    try {
      Socket s = new Socket("192.168.2.11", 1024);
      System.out.println(s);
    } catch (Exception e) {
      System.err.println("FAIL");
    }*/
  }
}